/*
 +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
 +
 +  intersect.h  -- contains constant definitions for intersection routines
 +
 +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
 */


#define NEAREST  0    /* flag indicating nearest intersection of obj desired */
#define LF       1    /* flag indicating first intersection of obj desired */


Boolean nearest_int(Ray i_ray, int *obj_no, Vector *int_val,
                    Vector *Pt_norm, Vector *patch_norm);

 
Boolean sphere_int (Ray ray, Sphere_Obj *s_ptr, Boolean norm_flg,
                    Vector *int_pt, Vector *pt_norm, Vector *norm, float *t);



Boolean poly_mesh_int(Ray ray, Poly_Mesh_Obj *obj_ptr, Boolean norm_flg,
                      int type, float *t_val, Vector *int_val,
                      Vector *Pt_norm, Vector *t_norm);

 
Boolean rect_int(Ray ray, Rect_Obj *r_ptr, Boolean norm_flg, float *t,
                 Vector *Pint, Vector *r_norm);

